"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }// src/index.ts


var _pluginutils = require('@windicss/plugin-utils');

// node_modules/windicss/utils/parser/index.mjs
var HTMLParser = function() {
  function HTMLParser2(html) {
    this.html = html;
  }
  HTMLParser2.prototype.parseClasses = function() {
    if (!this.html)
      return [];
    var classRegex = /class\s*=\s*(["'])(?:(?=(\\?))\2.)*?\1/;
    var quoteRegex = /["']/;
    var classNames = [];
    var _indexStart = 0;
    var _htmlLeft = this.html;
    var propStart = _htmlLeft.search(classRegex);
    while (propStart !== -1) {
      var afterMatch = _htmlLeft.substring(propStart);
      var relativeStart = afterMatch.search(quoteRegex);
      var relativeEnd = afterMatch.substring(relativeStart + 1).search(quoteRegex);
      var absoluteStart = propStart + relativeStart + 1;
      var absoluteEnd = absoluteStart + relativeEnd;
      classNames.push({
        start: _indexStart + absoluteStart,
        end: _indexStart + absoluteEnd,
        result: _htmlLeft.substring(absoluteStart, absoluteEnd)
      });
      _htmlLeft = _htmlLeft.substring(absoluteEnd + 2);
      _indexStart += absoluteEnd + 2;
      propStart = _htmlLeft.search(classRegex);
    }
    return classNames;
  };
  HTMLParser2.prototype.parseTags = function() {
    if (!this.html)
      return [];
    return Array.from(new Set(this.html.match(/<\w+/g))).map(function(i) {
      return i.substring(1);
    });
  };
  return HTMLParser2;
}();
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var extendStatics = function(d, b) {
  extendStatics = Object.setPrototypeOf || {__proto__: []} instanceof Array && function(d2, b2) {
    d2.__proto__ = b2;
  } || function(d2, b2) {
    for (var p in b2)
      if (Object.prototype.hasOwnProperty.call(b2, p))
        d2[p] = b2[p];
  };
  return extendStatics(d, b);
};
function __extends(d, b) {
  if (typeof b !== "function" && b !== null)
    throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
  extendStatics(d, b);
  function __() {
    this.constructor = d;
  }
  d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}
var __assign = function() {
  __assign = Object.assign || function __assign2(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p))
          t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __spreadArray(to, from) {
  for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
    to[j] = from[i];
  return to;
}
function toArray(v) {
  if (Array.isArray(v))
    return v;
  return [v];
}
function hash(str) {
  str = str.replace(/\r/g, "");
  var hash2 = 5381;
  var i = str.length;
  while (i--)
    hash2 = (hash2 << 5) - hash2 ^ str.charCodeAt(i);
  return (hash2 >>> 0).toString(36);
}
function indent(code, tab) {
  if (tab === void 0) {
    tab = 2;
  }
  var spaces = Array(tab).fill(" ").join("");
  return code.split("\n").map(function(line) {
    return spaces + line;
  }).join("\n");
}
function wrapit(code, start, end, tab, minify) {
  if (start === void 0) {
    start = "{";
  }
  if (end === void 0) {
    end = "}";
  }
  if (tab === void 0) {
    tab = 2;
  }
  if (minify === void 0) {
    minify = false;
  }
  if (minify)
    return "" + start + code + end;
  return start + "\n" + indent(code, tab) + "\n" + end;
}
function isSpace(str) {
  return /^\s*$/.test(str);
}
function camelToDash(str) {
  return str.replace(/([A-Z])/g, "-$1").replace(/^ms-/, "-ms-").toLowerCase();
}
function searchFrom(text, target, startIndex, endIndex) {
  if (startIndex === void 0) {
    startIndex = 0;
  }
  var subText = text.substring(startIndex, endIndex);
  var relativeIndex = subText.search(target);
  return relativeIndex === -1 ? -1 : startIndex + relativeIndex;
}
function connectList(a, b, append) {
  if (append === void 0) {
    append = true;
  }
  return append ? __spreadArray(__spreadArray([], a !== null && a !== void 0 ? a : []), b !== null && b !== void 0 ? b : []) : __spreadArray(__spreadArray([], b !== null && b !== void 0 ? b : []), a !== null && a !== void 0 ? a : []);
}
function deepCopy(source) {
  return Array.isArray(source) ? source.map(function(item) {
    return deepCopy(item);
  }) : source instanceof Date ? new Date(source.getTime()) : source && typeof source === "object" ? Object.getOwnPropertyNames(source).reduce(function(o, prop) {
    var descriptor = Object.getOwnPropertyDescriptor(source, prop);
    if (descriptor) {
      Object.defineProperty(o, prop, descriptor);
      if (source && typeof source === "object") {
        o[prop] = deepCopy(source[prop]);
      }
    }
    return o;
  }, Object.create(Object.getPrototypeOf(source))) : source;
}
function isTagName(name) {
  return ["a", "abbr", "address", "area", "article", "aside", "audio", "b", "base", "bdi", "bdo", "blockquote", "body", "br", "button", "canvas", "caption", "cite", "code", "col", "colgroup", "data", "datalist", "dd", "del", "details", "dfn", "dialog", "div", "dl", "dt", "em", "embd", "fieldset", "figcaption", "figure", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hr", "html", "i", "iframe", "img", "input", "ins", "kbd", "label", "legend", "li", "link", "main", "map", "mark", "meta", "meter", "nav", "noscript", "object", "ol", "optgroup", "option", "output", "p", "param", "picture", "pre", "progress", "q", "rp", "rt", "ruby", "s", "samp", "script", "section", "select", "small", "source", "span", "strong", "style", "sub", "summary", "sup", "svg", "table", "tbody", "td", "template", "textarea", "tfoot", "th", "thead", "time", "title", "tr", "track", "u", "ul", "var", "video", "wbr"].includes(name);
}
function searchPropEnd(text, startIndex) {
  if (startIndex === void 0) {
    startIndex = 0;
  }
  var index = startIndex;
  var output = -1;
  var openSingleQuote = false;
  var openDoubleQuote = false;
  while (index < text.length) {
    switch (text.charAt(index)) {
      case "'":
        if (text.charAt(index - 1) !== "\\")
          openSingleQuote = !openSingleQuote;
        break;
      case '"':
        if (text.charAt(index - 1) !== "\\")
          openDoubleQuote = !openDoubleQuote;
        break;
      case ";":
        if (openSingleQuote === false && openDoubleQuote === false)
          output = index;
        break;
    }
    if (output !== -1)
      break;
    index++;
  }
  return output;
}
var Property = function() {
  function Property2(name, value, comment, important) {
    if (important === void 0) {
      important = false;
    }
    this.meta = {type: "utilities", group: "plugin", order: 99999};
    this.name = name;
    this.value = value;
    this.comment = comment;
    this.important = important;
  }
  Property2._singleParse = function(css) {
    css = css.trim();
    if (!css)
      return;
    if (css.charAt(0) === "@")
      return InlineAtRule.parse(css);
    var split = css.search(":");
    var end = searchPropEnd(css);
    if (split === -1)
      return;
    var important = false;
    var prop = css.substring(split + 1, end === -1 ? void 0 : end).trim();
    if (/!important;?$/.test(prop)) {
      important = true;
      prop = prop.replace(/!important/, "").trimRight();
    }
    return new Property2(css.substring(0, split).trim(), prop, void 0, important);
  };
  Property2.parse = function(css) {
    if (!/;\s*$/.test(css))
      css += ";";
    var properties = [];
    var index = 0;
    var end = searchPropEnd(css, index);
    while (end !== -1) {
      var parsed = this._singleParse(css.substring(searchFrom(css, /\S/, index), end + 1));
      if (parsed)
        properties.push(parsed);
      index = end + 1;
      end = searchPropEnd(css, index);
    }
    var count = properties.length;
    if (count > 1)
      return properties;
    if (count === 1)
      return properties[0];
  };
  Property2.prototype.clone = function() {
    return deepCopy(this);
  };
  Property2.prototype.toStyle = function(selector) {
    return new Style(selector, this, this.important).updateMeta(this.meta);
  };
  Property2.prototype.build = function(minify) {
    var _this = this;
    if (minify === void 0) {
      minify = false;
    }
    var createProperty = function(name, value) {
      if (minify) {
        return name + ":" + value + (_this.important ? "!important" : "") + ";";
      } else {
        var p = name + ": " + value + (_this.important ? " !important" : "") + ";";
        return _this.comment ? p + (" /* " + _this.comment + " */") : p;
      }
    };
    if (!this.value)
      return "";
    return typeof this.name === "string" ? createProperty(this.name, this.value) : this.name.map(function(i) {
      return createProperty(i, _this.value);
    }).join(minify ? "" : "\n");
  };
  Property2.prototype.updateMeta = function(meta) {
    this.meta = meta;
    return this;
  };
  return Property2;
}();
var InlineAtRule = function(_super) {
  __extends(InlineAtRule2, _super);
  function InlineAtRule2(name, value, important) {
    if (important === void 0) {
      important = false;
    }
    var _this = _super.call(this, name, value, void 0, important) || this;
    _this.name = name;
    return _this;
  }
  InlineAtRule2.parse = function(css) {
    var _a;
    var matchName = css.match(/@[^\s;{}]+/);
    if (matchName) {
      var name_1 = matchName[0].substring(1);
      var important = false;
      var expression = matchName.index !== void 0 ? (_a = css.substring(matchName.index + name_1.length + 1).match(/(?:(['"]).*?\1|[^;])*/)) === null || _a === void 0 ? void 0 : _a[0].trim() : void 0;
      if (expression && /!important;?$/.test(expression)) {
        important = true;
        expression = expression.replace(/!important/, "").trimRight();
      }
      return new InlineAtRule2(name_1, expression === "" ? void 0 : expression, important);
    }
  };
  InlineAtRule2.prototype.build = function() {
    return this.value ? "@" + this.name + " " + this.value + (this.important ? " !important" : "") + ";" : "@" + this.name + (this.important ? " !important" : "") + ";";
  };
  return InlineAtRule2;
}(Property);
var Style = function() {
  function Style2(selector, property, important) {
    if (important === void 0) {
      important = false;
    }
    this.meta = {type: "components", group: "plugin", order: 99999};
    this.selector = selector;
    this.important = important;
    this.property = toArray(property || []);
  }
  Object.defineProperty(Style2.prototype, "rule", {
    get: function() {
      var _this = this;
      var _a, _b, _c;
      var selectors = ((_a = this.selector) !== null && _a !== void 0 ? _a : "").trim().split(/\s*,\s*/g);
      this._parentSelectors && (selectors = selectors.map(function(i) {
        var _a2;
        return ((_a2 = _this._parentSelectors) === null || _a2 === void 0 ? void 0 : _a2.join(" ")) + " " + i;
      }));
      ((_b = this._wrapSelectors) !== null && _b !== void 0 ? _b : []).forEach(function(func) {
        return selectors = selectors.map(function(i) {
          return func(i);
        });
      });
      this._pseudoClasses && (selectors = selectors.map(function(i) {
        var _a2;
        return i + (":" + ((_a2 = _this._pseudoClasses) === null || _a2 === void 0 ? void 0 : _a2.join(":")));
      }));
      this._pseudoElements && (selectors = selectors.map(function(i) {
        var _a2;
        return i + ("::" + ((_a2 = _this._pseudoElements) === null || _a2 === void 0 ? void 0 : _a2.join("::")));
      }));
      this._brotherSelectors && (selectors = selectors.map(function(i) {
        var _a2;
        return i + ("." + ((_a2 = _this._brotherSelectors) === null || _a2 === void 0 ? void 0 : _a2.join(".")));
      }));
      this._childSelectors && (selectors = selectors.map(function(i) {
        var _a2;
        return i + (" " + ((_a2 = _this._childSelectors) === null || _a2 === void 0 ? void 0 : _a2.join(" ")));
      }));
      ((_c = this._wrapRules) !== null && _c !== void 0 ? _c : []).forEach(function(func) {
        return selectors = selectors.map(function(i) {
          return func(i);
        });
      });
      return selectors.join(", ");
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Style2.prototype, "pseudoClasses", {
    get: function() {
      return this._pseudoClasses;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Style2.prototype, "pseudoElements", {
    get: function() {
      return this._pseudoElements;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Style2.prototype, "parentSelectors", {
    get: function() {
      return this._parentSelectors;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Style2.prototype, "childSelectors", {
    get: function() {
      return this._childSelectors;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Style2.prototype, "brotherSelectors", {
    get: function() {
      return this._brotherSelectors;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Style2.prototype, "wrapProperties", {
    get: function() {
      return this._wrapProperties;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Style2.prototype, "wrapSelectors", {
    get: function() {
      return this._wrapSelectors;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Style2.prototype, "wrapRules", {
    get: function() {
      return this._wrapRules;
    },
    enumerable: false,
    configurable: true
  });
  Object.defineProperty(Style2.prototype, "simple", {
    get: function() {
      return !(this.atRules || this._pseudoClasses || this._pseudoElements || this._parentSelectors || this._childSelectors || this._brotherSelectors || this._wrapProperties || this._wrapSelectors || this._wrapRules);
    },
    enumerable: false,
    configurable: true
  });
  Style2.generate = function(parent, property, root) {
    if (!root)
      root = (parent === null || parent === void 0 ? void 0 : parent.startsWith("@")) ? new Style2().atRule(parent) : new Style2(parent);
    var output = [];
    var _loop_1 = function(key2, value2) {
      if (typeof value2 === "string") {
        root.add(new Property(camelToDash(key2), value2));
      } else if (Array.isArray(value2)) {
        value2.map(function(i) {
          return root === null || root === void 0 ? void 0 : root.add(new Property(camelToDash(key2), i));
        });
      } else {
        var wrap = deepCopy(root);
        wrap.property = [];
        var child = void 0;
        if (key2.startsWith("@")) {
          child = wrap.atRule(key2, false);
        } else {
          if (wrap.selector === void 0) {
            wrap.selector = key2;
            child = wrap;
          } else {
            if (/^[a-z]+$/.test(key2) && !isTagName(key2)) {
              wrap.wrapProperty(function(property2) {
                return key2 + "-" + property2;
              });
              child = wrap;
            } else {
              var _hKey_1 = function(selector, key3) {
                return (/&/.test(key3) ? key3 : "& " + key3).replace("&", selector);
              };
              wrap.wrapSelector(function(selector) {
                return selector.trim().split(/\s*,\s*/g).map(function(s) {
                  return key2.split(/\s*,\s*/g).map(function(i) {
                    return _hKey_1(s, i);
                  }).join(", ");
                }).join(", ");
              });
              child = wrap;
            }
          }
        }
        output = output.concat(Style2.generate(key2.startsWith("@") ? void 0 : key2, value2, child));
      }
    };
    for (var _i = 0, _a = Object.entries(property !== null && property !== void 0 ? property : {}); _i < _a.length; _i++) {
      var _b = _a[_i], key = _b[0], value = _b[1];
      _loop_1(key, value);
    }
    if (root.property.length > 0)
      output.unshift(root);
    return output;
  };
  Style2.prototype.atRule = function(atrule, append) {
    if (append === void 0) {
      append = true;
    }
    if (!atrule)
      return this;
    if (this.atRules) {
      append ? this.atRules.push(atrule) : this.atRules.unshift(atrule);
    } else {
      this.atRules = [atrule];
    }
    return this;
  };
  Style2.prototype.pseudoClass = function(string) {
    if (this._pseudoClasses) {
      this._pseudoClasses.push(string);
    } else {
      this._pseudoClasses = [string];
    }
    return this;
  };
  Style2.prototype.pseudoElement = function(string) {
    if (this._pseudoElements) {
      this._pseudoElements.push(string);
    } else {
      this._pseudoElements = [string];
    }
    return this;
  };
  Style2.prototype.brother = function(string) {
    if (this._brotherSelectors) {
      this._brotherSelectors.push(string);
    } else {
      this._brotherSelectors = [string];
    }
    return this;
  };
  Style2.prototype.parent = function(string) {
    if (this._parentSelectors) {
      this._parentSelectors.push(string);
    } else {
      this._parentSelectors = [string];
    }
    return this;
  };
  Style2.prototype.child = function(string) {
    if (this._childSelectors) {
      this._childSelectors.push(string);
    } else {
      this._childSelectors = [string];
    }
    return this;
  };
  Style2.prototype.wrapProperty = function(func) {
    if (this._wrapProperties) {
      this._wrapProperties.push(func);
    } else {
      this._wrapProperties = [func];
    }
    return this;
  };
  Style2.prototype.wrapSelector = function(func) {
    if (this._wrapSelectors) {
      this._wrapSelectors.push(func);
    } else {
      this._wrapSelectors = [func];
    }
    return this;
  };
  Style2.prototype.wrapRule = function(func) {
    if (this._wrapRules) {
      this._wrapRules.push(func);
    } else {
      this._wrapRules = [func];
    }
    return this;
  };
  Style2.prototype.add = function(item) {
    item = toArray(item);
    if (this.important)
      item.forEach(function(i) {
        return i.important = true;
      });
    this.property = __spreadArray(__spreadArray([], this.property), item);
    return this;
  };
  Style2.prototype.extend = function(item, onlyProperty, append) {
    if (onlyProperty === void 0) {
      onlyProperty = false;
    }
    if (append === void 0) {
      append = true;
    }
    if (!item)
      return this;
    if (item.wrapProperties) {
      var props_1 = [];
      item.property.forEach(function(p) {
        var _a;
        var pc = new Property(p.name, p.value, p.comment);
        (_a = item.wrapProperties) === null || _a === void 0 ? void 0 : _a.forEach(function(wrap) {
          pc.name = Array.isArray(pc.name) ? pc.name.map(function(i) {
            return wrap(i);
          }) : wrap(pc.name);
        });
        if (item.important)
          pc.important = true;
        props_1.push(pc);
      });
      this.property = connectList(this.property, props_1, append);
    } else {
      if (item.important)
        item.property.forEach(function(i) {
          return i.important = true;
        });
      this.property = connectList(this.property, item.property, append);
    }
    if (onlyProperty)
      return this;
    item.selector && (this.selector = item.selector);
    this.meta = item.meta;
    item.atRules && (this.atRules = connectList(item.atRules, this.atRules, append));
    item._brotherSelectors && (this._brotherSelectors = connectList(this._brotherSelectors, item._brotherSelectors, append));
    item._childSelectors && (this._childSelectors = connectList(this._childSelectors, item._childSelectors, append));
    item._parentSelectors && (this._parentSelectors = connectList(this._parentSelectors, item._parentSelectors, append));
    item._pseudoClasses && (this._pseudoClasses = connectList(this._pseudoClasses, item._pseudoClasses, append));
    item._pseudoElements && (this._pseudoElements = connectList(this._pseudoElements, item._pseudoElements, append));
    item._wrapRules && (this._wrapRules = connectList(this._wrapRules, item._wrapRules, append));
    item._wrapSelectors && (this._wrapSelectors = connectList(this._wrapSelectors, item._wrapSelectors, append));
    return this;
  };
  Style2.prototype.clean = function() {
    var property = [];
    var cache = [];
    this.property.forEach(function(i) {
      var inline = i.build();
      if (!cache.includes(inline)) {
        cache.push(inline);
        property.push(i);
      }
    });
    this.property = property;
    return this;
  };
  Style2.prototype.flat = function() {
    var properties = [];
    this.property.forEach(function(p) {
      if (Array.isArray(p.name)) {
        p.name.forEach(function(i) {
          properties.push(new Property(i, p.value, p.comment));
        });
      } else {
        properties.push(p);
      }
    });
    this.property = properties;
    return this;
  };
  Style2.prototype.clone = function(selector, property) {
    var newStyle = deepCopy(this);
    if (selector)
      newStyle.selector = selector;
    if (property)
      newStyle.property = Array.isArray(property) ? property : [property];
    return newStyle;
  };
  Style2.prototype.sort = function() {
    this.property = this.property.sort(function(a, b) {
      return ("" + a.name).substring(0, 2) > ("" + b.name).substring(0, 2) ? 1 : -1;
    });
    return this;
  };
  Style2.prototype.build = function(minify, prefixer) {
    var _this = this;
    if (minify === void 0) {
      minify = false;
    }
    if (prefixer === void 0) {
      prefixer = true;
    }
    var properties = this.property;
    if (!prefixer)
      properties = properties.filter(function(p) {
        if (p.value && /-(webkit|ms|moz|o)-/.test(p.value))
          return false;
        if (Array.isArray(p.name)) {
          p.name = p.name.filter(function(i) {
            return !/^-(webkit|ms|moz|o)-/.test(i);
          });
          return true;
        }
        return !/^-(webkit|ms|moz|o)-/.test(p.name);
      });
    var result = properties.map(function(p) {
      if (_this._wrapProperties) {
        var name_2 = p.name;
        _this._wrapProperties.forEach(function(w) {
          return name_2 = Array.isArray(name_2) ? name_2.map(function(n) {
            return w(n);
          }) : w(name_2);
        });
        return new Property(name_2, p.value, p.comment, _this.important ? true : p.important).build(minify);
      }
      return _this.important ? new Property(p.name, p.value, p.comment, true).build(minify) : p.build(minify);
    }).join(minify ? "" : "\n");
    if (!this.selector && !this.atRules)
      return result.replace(/;}/g, "}");
    if (this.selector)
      result = (minify ? this.rule.replace(/,\s/g, ",") : this.rule + " ") + wrapit(result, void 0, void 0, void 0, result !== "" ? minify : true);
    if (this.atRules) {
      for (var _i = 0, _a = this.atRules; _i < _a.length; _i++) {
        var rule = _a[_i];
        result = minify ? "" + rule.replace(/\s/g, "") + wrapit(result, void 0, void 0, void 0, minify) : rule + " " + wrapit(result, void 0, void 0, void 0, result !== "" ? minify : true);
      }
    }
    return minify ? result.replace(/;}/g, "}") : result;
  };
  Style2.prototype.updateMeta = function(meta) {
    this.meta = meta;
    return this;
  };
  return Style2;
}();
(function(_super) {
  __extends(GlobalStyle, _super);
  function GlobalStyle(selector, property, important) {
    return _super.call(this, selector, property, important) || this;
  }
  return GlobalStyle;
})(Style);
var Keyframes = function(_super) {
  __extends(Keyframes2, _super);
  function Keyframes2(selector, property, important) {
    return _super.call(this, selector, property, important) || this;
  }
  Keyframes2.generate = function(name, children, root, prefixer) {
    if (prefixer === void 0) {
      prefixer = true;
    }
    var output = [];
    for (var _i = 0, _a = Object.entries(children); _i < _a.length; _i++) {
      var _b = _a[_i], key = _b[0], value = _b[1];
      var style = new Keyframes2(key).atRule("@keyframes " + name);
      var webkitStyle = new Keyframes2(key).atRule("@-webkit-keyframes " + name);
      for (var _c = 0, _d = Object.entries(value); _c < _d.length; _c++) {
        var _e = _d[_c], pkey = _e[0], pvalue = _e[1];
        var prop = pkey;
        if (pkey === "transform") {
          prop = prefixer ? ["-webkit-transform", "transform"] : "transform";
        } else if (["animationTimingFunction", "animation-timing-function"].includes(pkey)) {
          prop = prefixer ? [
            "-webkit-animation-timing-function",
            "animation-timing-function"
          ] : "animation-timing-function";
        }
        style.add(new Property(prop, pvalue));
        webkitStyle.add(new Property(prop, pvalue));
      }
      output.push(style);
      if (prefixer)
        output.push(webkitStyle);
    }
    return output;
  };
  return Keyframes2;
}(Style);
var Container = function(_super) {
  __extends(Container2, _super);
  function Container2(selector, property, important) {
    return _super.call(this, selector, property, important) || this;
  }
  return Container2;
}(Style);
var variantOrder;
(function(variantOrder2) {
  variantOrder2[variantOrder2["first"] = 0] = "first";
  variantOrder2[variantOrder2["last"] = 1] = "last";
  variantOrder2[variantOrder2["odd"] = 2] = "odd";
  variantOrder2[variantOrder2["even"] = 3] = "even";
  variantOrder2[variantOrder2["visited"] = 4] = "visited";
  variantOrder2[variantOrder2["checked"] = 5] = "checked";
  variantOrder2[variantOrder2["group-hover"] = 6] = "group-hover";
  variantOrder2[variantOrder2["group-focus"] = 7] = "group-focus";
  variantOrder2[variantOrder2["focus-within"] = 8] = "focus-within";
  variantOrder2[variantOrder2["hover"] = 9] = "hover";
  variantOrder2[variantOrder2["focus"] = 10] = "focus";
  variantOrder2[variantOrder2["focus-visible"] = 11] = "focus-visible";
  variantOrder2[variantOrder2["active"] = 12] = "active";
  variantOrder2[variantOrder2["disabled"] = 13] = "disabled";
})(variantOrder || (variantOrder = {}));
var layerOrder = {
  base: 10,
  components: 150,
  shortcuts: 160,
  utilities: 5e4
};
var keyOrder = {
  container: 201,
  space: 202,
  divide: 203,
  bg: 204,
  from: 205,
  via: 206,
  to: 207,
  border: 208,
  rounded: 209,
  cursor: 210,
  flex: 211,
  order: 212,
  font: 213,
  h: 214,
  list: 215,
  m: 216,
  my: 217,
  mx: 218,
  mt: 219,
  mr: 220,
  mb: 221,
  ml: 222,
  min: 223,
  max: 224,
  object: 225,
  opacity: 226,
  outline: 227,
  p: 228,
  py: 229,
  px: 230,
  pt: 231,
  pr: 232,
  pb: 233,
  pl: 234,
  placeholder: 235,
  inset: 236,
  top: 237,
  right: 238,
  bottom: 239,
  left: 240,
  shadow: 241,
  ring: 242,
  fill: 243,
  stroke: 244,
  text: 245,
  leading: 246,
  tracking: 247,
  w: 248,
  z: 249,
  gap: 250,
  auto: 251,
  grid: 252,
  col: 253,
  row: 254,
  transform: 255,
  origin: 256,
  scale: 257,
  rotate: 258,
  translate: 259,
  skew: 260,
  transition: 261,
  ease: 262,
  duration: 263,
  delay: 264,
  animate: 265
};
function getWeights(a) {
  var first = a.charAt(0);
  var second = a.charAt(1);
  if (first === ":" && second === ":")
    return 59;
  if (first === "#")
    return 500;
  if (first !== ".")
    return first.charCodeAt(0);
  var matches = a.match(/\w+/);
  var key = matches ? matches[0] : void 0;
  if (key && keyOrder[key])
    return keyOrder[key];
  return 499;
}
function sortMeta(a, b) {
  return a.meta.order - b.meta.order;
}
function sortSelector(a, b) {
  if (a.selector && b.selector) {
    return getWeights(a.selector) - getWeights(b.selector);
  }
  return 0;
}
var minMaxWidth = /(!?\(\s*min(-device-)?-width).+\(\s*max(-device)?-width/i;
var minWidth = /\(\s*min(-device)?-width/i;
var maxMinWidth = /(!?\(\s*max(-device)?-width).+\(\s*min(-device)?-width/i;
var maxWidth = /\(\s*max(-device)?-width/i;
var isMinWidth = _testQuery(minMaxWidth, maxMinWidth, minWidth);
var isMaxWidth = _testQuery(maxMinWidth, minMaxWidth, maxWidth);
var minMaxHeight = /(!?\(\s*min(-device)?-height).+\(\s*max(-device)?-height/i;
var minHeight = /\(\s*min(-device)?-height/i;
var maxMinHeight = /(!?\(\s*max(-device)?-height).+\(\s*min(-device)?-height/i;
var maxHeight = /\(\s*max(-device)?-height/i;
var isMinHeight = _testQuery(minMaxHeight, maxMinHeight, minHeight);
var isMaxHeight = _testQuery(maxMinHeight, minMaxHeight, maxHeight);
var isPrint = /print/i;
var isPrintOnly = /^print\$/i;
var isAtRule = /^\s*@/i;
var isMedia = /^\s*@media/i;
var maxValue = Number.MAX_VALUE;
function _getQueryLength(length) {
  var result = /(-?\d*\.?\d+)(ch|em|ex|px|rem)/.exec(length);
  if (result === null) {
    return maxValue;
  }
  var number = result[1];
  var unit = result[2];
  switch (unit) {
    case "ch":
      return parseFloat(number) * 8.8984375;
    case "em":
    case "rem":
      return parseFloat(number) * 16;
    case "ex":
      return parseFloat(number) * 8.296875;
    case "px":
      return parseFloat(number);
  }
  return +number;
}
function _testQuery(doubleTestTrue, doubleTestFalse, singleTest) {
  return function(query) {
    if (doubleTestTrue.test(query)) {
      return true;
    } else if (doubleTestFalse.test(query)) {
      return false;
    }
    return singleTest.test(query);
  };
}
function _testAtRule(a, b) {
  var isMediaA = isMedia.test(a);
  var isMediaB = isMedia.test(b);
  if (isMediaA && isMediaB)
    return null;
  var isAtRuleA = isAtRule.test(a);
  var isAtRuleB = isAtRule.test(b);
  if (isAtRuleA)
    return 1;
  if (isAtRuleB)
    return -1;
  return 0;
}
function _testIsPrint(a, b) {
  var isPrintA = isPrint.test(a);
  var isPrintOnlyA = isPrintOnly.test(a);
  var isPrintB = isPrint.test(b);
  var isPrintOnlyB = isPrintOnly.test(b);
  if (isPrintA && isPrintB) {
    if (!isPrintOnlyA && isPrintOnlyB) {
      return 1;
    }
    if (isPrintOnlyA && !isPrintOnlyB) {
      return -1;
    }
    return a.localeCompare(b);
  }
  if (isPrintA) {
    return 1;
  }
  if (isPrintB) {
    return -1;
  }
  return null;
}
function sortMediaQuery(a, b) {
  var testAtRule = _testAtRule(a, b);
  if (testAtRule !== null)
    return testAtRule;
  var testIsPrint = _testIsPrint(a, b);
  if (testIsPrint !== null)
    return testIsPrint;
  var minA = isMinWidth(a) || isMinHeight(a);
  var maxA = isMaxWidth(a) || isMaxHeight(a);
  var minB = isMinWidth(b) || isMinHeight(b);
  var maxB = isMaxWidth(b) || isMaxHeight(b);
  if (minA && maxB) {
    return -1;
  }
  if (maxA && minB) {
    return 1;
  }
  var lengthA = _getQueryLength(a);
  var lengthB = _getQueryLength(b);
  if (lengthA === maxValue && lengthB === maxValue) {
    return a.localeCompare(b);
  } else if (lengthA === maxValue) {
    return 1;
  } else if (lengthB === maxValue) {
    return -1;
  }
  if (lengthA > lengthB) {
    if (maxA) {
      return -1;
    }
    return 1;
  }
  if (lengthA < lengthB) {
    if (maxA) {
      return 1;
    }
    return -1;
  }
  return a.localeCompare(b);
}
function combineObject(a, b) {
  var output = __assign({}, a);
  for (var _i = 0, _a = Object.entries(b); _i < _a.length; _i++) {
    var _b = _a[_i], key_of_b = _b[0], value_of_b = _b[1];
    if (key_of_b in a) {
      var value_of_a = a[key_of_b];
      if (value_of_a !== value_of_b) {
        if (value_of_b !== null && value_of_b.constructor !== Object) {
          output[key_of_b] = [value_of_a, value_of_b];
        } else if (value_of_a !== null && value_of_a.constructor === Object) {
          output[key_of_b] = combineObject(value_of_a, value_of_b);
        } else {
          output[key_of_b] = [
            value_of_a,
            combineObject(value_of_a, value_of_b)
          ];
        }
      }
    } else {
      output[key_of_b] = value_of_b;
    }
  }
  return output;
}
function deepList(list, value) {
  var key = list.pop();
  var current = value ? value : {};
  if (!key)
    return current;
  var dict = {};
  dict[key] = current;
  return deepList(list, dict);
}
function handleNest(item) {
  var output = [];
  if (Array.isArray(item)) {
    item.forEach(function(i) {
      output = __spreadArray(__spreadArray([], output), handleNest(i));
    });
  } else {
    if (item.build)
      output.push(item.build());
  }
  return output;
}
function buildMap(obj, minify, prefixer) {
  if (minify === void 0) {
    minify = false;
  }
  if (prefixer === void 0) {
    prefixer = true;
  }
  var output = [];
  if (Array.isArray(obj)) {
    obj.forEach(function(item) {
      if (item.constructor === Object) {
        output.push(buildMap(item));
      } else if (Array.isArray(item)) {
        output = __spreadArray(__spreadArray([], output), handleNest(item));
      } else {
        if (item.build)
          output.push(item.build(minify));
      }
    });
  } else if (obj && typeof obj === "object") {
    var _loop_1 = function(key2, value2) {
      var _gstyle = function(v) {
        return (minify ? key2.replace(/\n/g, "") : key2 + " ") + wrapit(v, void 0, void 0, void 0, minify);
      };
      if (value2 instanceof Style) {
        output.push(_gstyle(value2.build(minify, prefixer)));
      } else if (value2 && typeof value2 === "object") {
        output.push(_gstyle(buildMap(value2, minify, prefixer)));
      }
    };
    for (var _i = 0, _a = Object.entries(obj); _i < _a.length; _i++) {
      var _b = _a[_i], key = _b[0], value = _b[1];
      _loop_1(key, value);
    }
  }
  return output.join(minify ? "" : "\n");
}
function combineSelector(styleList) {
  var styleMap = {};
  var passed = [];
  styleList.forEach(function(style) {
    var rule = style.rule;
    if (rule) {
      var hashValue = hash(rule);
      if (hashValue in styleMap) {
        styleMap[hashValue] = styleMap[hashValue].extend(style, true);
      } else {
        styleMap[hashValue] = style;
      }
    } else {
      passed.push(style);
    }
  });
  return __spreadArray(__spreadArray([], passed), Object.values(styleMap).map(function(style) {
    return style.clean();
  }));
}
function buildAtRule(styleList, minify, prefixer, reverse) {
  if (minify === void 0) {
    minify = false;
  }
  if (prefixer === void 0) {
    prefixer = true;
  }
  if (reverse === void 0) {
    reverse = false;
  }
  var ruleMap = styleList.map(function(i) {
    var _a, _b;
    var list = __spreadArray(__spreadArray([], reverse ? ((_a = i.atRules) !== null && _a !== void 0 ? _a : []).sort(sortMediaQuery) : ((_b = i.atRules) !== null && _b !== void 0 ? _b : []).sort(sortMediaQuery).reverse()), [
      i.rule
    ]);
    var style = new Style(void 0, i.property, i.important).updateMeta(i.meta);
    i.wrapProperties && i.wrapProperties.forEach(function(wrap) {
      return style.wrapProperty(wrap);
    });
    return deepList(list, style);
  }).sort(function(a, b) {
    var akey = Object.keys(a)[0];
    var bkey = Object.keys(b)[0];
    return sortMediaQuery(akey, bkey);
  });
  return buildMap(ruleMap.reduce(function(previousValue, currentValue) {
    return combineObject(previousValue, currentValue);
  }, {}), minify, prefixer);
}
function compileStyleSheet(styleList, minify, prefixer) {
  if (minify === void 0) {
    minify = false;
  }
  if (prefixer === void 0) {
    prefixer = true;
  }
  var head = combineSelector(styleList.filter(function(i) {
    return !(i.selector && i.atRules) && !(i instanceof Container);
  }).sort(sortMeta)).map(function(i) {
    return i.build(minify, prefixer);
  }).join(minify ? "" : "\n");
  var containers = {};
  styleList.filter(function(i) {
    return i instanceof Container;
  }).forEach(function(i) {
    if (i.selector && i.selector in containers) {
      containers[i.selector].push(i);
    } else if (i.selector) {
      containers[i.selector] = [i];
    }
  });
  var topStyles = Object.values(containers).map(function(i) {
    return buildAtRule(i, minify, prefixer, true);
  });
  var keyframes = buildAtRule(styleList.filter(function(i) {
    return i instanceof Keyframes;
  }), minify, prefixer);
  if (keyframes)
    topStyles.unshift(keyframes);
  var top = topStyles.join(minify ? "" : "\n");
  var body = buildAtRule(styleList.filter(function(i) {
    return i.selector && i.atRules && !(i instanceof Keyframes || i instanceof Container);
  }).sort(sortMeta), minify, prefixer);
  return minify ? (top + head + body).replace(/;\}/g, "}") : [top, head, body].filter(function(i) {
    return !isSpace(i);
  }).join("\n");
}
var StyleSheet = function() {
  function StyleSheet2(children) {
    this.prefixer = true;
    this.children = children || [];
  }
  StyleSheet2.prototype.add = function(item) {
    if (!item)
      return this;
    if (Array.isArray(item)) {
      this.children = __spreadArray(__spreadArray([], this.children), item);
    } else {
      this.children.push(item);
    }
    return this;
  };
  StyleSheet2.prototype.extend = function(styleSheet, append, dedup) {
    if (append === void 0) {
      append = true;
    }
    if (dedup === void 0) {
      dedup = false;
    }
    if (styleSheet) {
      var extended = styleSheet.children;
      if (dedup) {
        var hashes_1 = extended.map(function(i) {
          return hash(i.build());
        });
        extended = extended.filter(function(i) {
          return !hashes_1.includes(hash(i.build()));
        });
      }
      this.prefixer = styleSheet.prefixer;
      this.children = append ? __spreadArray(__spreadArray([], this.children), extended) : __spreadArray(__spreadArray([], extended), this.children);
    }
    return this;
  };
  StyleSheet2.prototype.combine = function() {
    var styleMap = {};
    this.children.forEach(function(style, index) {
      var _a;
      var hashValue = hash(style.atRules + style.rule);
      if (hashValue in styleMap) {
        if ((_a = style.atRules) === null || _a === void 0 ? void 0 : _a.includes("@font-face")) {
          styleMap[hashValue + index] = style;
        } else {
          styleMap[hashValue] = styleMap[hashValue].extend(style, true);
        }
      } else {
        styleMap[hashValue] = style;
      }
    });
    this.children = Object.values(styleMap).map(function(i) {
      return i.clean();
    });
    return this;
  };
  StyleSheet2.prototype.layer = function(type) {
    var styleSheet = new StyleSheet2(this.children.filter(function(i) {
      return i.meta.type === type;
    }));
    styleSheet.prefixer = this.prefixer;
    return styleSheet;
  };
  StyleSheet2.prototype.split = function() {
    return {
      base: this.layer("base"),
      components: this.layer("components"),
      utilities: this.layer("utilities")
    };
  };
  StyleSheet2.prototype.clone = function() {
    return deepCopy(this);
  };
  StyleSheet2.prototype.sort = function(meta) {
    if (meta === void 0) {
      meta = false;
    }
    this.children = meta ? this.children.sort(function(a, b) {
      return a.meta.order - b.meta.order;
    }) : this.children.sort(sortSelector);
    return this;
  };
  StyleSheet2.prototype.build = function(minify) {
    if (minify === void 0) {
      minify = false;
    }
    return compileStyleSheet(this.children, minify, this.prefixer);
  };
  return StyleSheet2;
}();
var regexRemoveComments = [
  new RegExp("[\\s\\t]*\\/\\*.+?\\*\\/", "gs"),
  new RegExp("[\\s\\t]*:?\\/\\/.*$", "gm")
];
var CSSParser = function() {
  function CSSParser2(css, processor) {
    this._cache = {};
    this.css = css;
    this.processor = processor;
  }
  CSSParser2.prototype._addCache = function(style) {
    var rule = style.rule;
    if ([".", "#"].includes(rule.charAt(0)))
      this._cache[rule] = rule in this._cache ? __spreadArray(__spreadArray([], this._cache[rule]), [deepCopy(style)]) : [deepCopy(style)];
  };
  CSSParser2.prototype._removeComment = function(css) {
    if (!css)
      return css;
    css = css.replace(regexRemoveComments[0], "");
    css = css.replace(regexRemoveComments[1], function(match) {
      if (match.replace(/[\s\t]*/, "").startsWith("://"))
        return match;
      return "";
    });
    return css;
  };
  CSSParser2.prototype._searchGroup = function(text, startIndex) {
    if (startIndex === void 0) {
      startIndex = 0;
    }
    var level = 1;
    var endBracket = searchFrom(text, "}", startIndex);
    while (endBracket !== -1) {
      var nextBracket = searchFrom(text, "{", startIndex);
      if (endBracket < nextBracket || nextBracket === -1) {
        level--;
        startIndex = endBracket + 1;
        if (level === 0)
          return endBracket;
      } else {
        level++;
        startIndex = nextBracket + 1;
      }
      endBracket = searchFrom(text, "}", startIndex);
    }
    return -1;
  };
  CSSParser2.prototype._loadTheme = function(prop) {
    if (!prop)
      return;
    if (!this.processor)
      return prop;
    var index = 0;
    var output = [];
    while (index < prop.length) {
      var matched = prop.slice(index).match(/theme\([^)]*?\)/);
      if (!matched || matched.index === void 0)
        break;
      output.push(prop.slice(index, index + matched.index));
      var args = matched[0].slice(6, -1).split(/\s*,\s*/).map(function(i) {
        return i.trim().replace(/^['"]+|['"]+$/g, "");
      });
      output.push(this.processor.theme(args[0], args[1]));
      index += matched.index + matched[0].length;
    }
    output.push(prop.slice(index));
    return output.join("");
  };
  CSSParser2.prototype._handleDirectives = function(atrule) {
    var _a, _b, _c;
    if (!this.processor)
      return {atrule};
    var iatrule = InlineAtRule.parse(atrule);
    if (!iatrule)
      return;
    if (iatrule.name === "apply")
      return {apply: iatrule.value, important: iatrule.important};
    if (iatrule.name === "layer")
      return {layer: (_a = iatrule.value) !== null && _a !== void 0 ? _a : "components"};
    if (iatrule.name === "variants" && iatrule.value)
      return {variants: iatrule.value.split(",").map(function(i) {
        return i.trim().split(":");
      })};
    if (iatrule.name === "screen" && iatrule.value) {
      var screens = this.processor.resolveVariants("screen");
      if (iatrule.value in screens)
        return {atrule: (_c = (_b = screens[iatrule.value]().atRules) === null || _b === void 0 ? void 0 : _b[0]) !== null && _c !== void 0 ? _c : atrule};
      if (["dark", "light"].includes(iatrule.value))
        return {atrule: "@media (prefers-color-scheme: " + iatrule.value + ")"};
    }
    return {atrule};
  };
  CSSParser2.prototype._generateNestProperty = function(props, parent, parentType) {
    var style = new Style(void 0, props);
    if (!parent || !parentType)
      return style;
    if (parentType === "selector") {
      style.selector = parent;
      return style;
    }
    return style.atRule(parent);
  };
  CSSParser2.prototype._generateNestStyle = function(styles, parent, parentType) {
    var _this = this;
    var layer = "components";
    var order = layerOrder["components"];
    var group = "block";
    if (!parent)
      return styles;
    if (parentType === "selector") {
      styles.forEach(function(i) {
        if (i instanceof Keyframes)
          return;
        if (!i.selector) {
          i.selector = parent;
        } else {
          var selector_1 = i.selector;
          selector_1 = selector_1.trim().split(/\s*,\s*/g).map(function(i2) {
            return /&/.test(i2) ? i2 : "& " + i2;
          }).join(", ");
          i.selector = /\s*,\s*/.test(parent) ? parent.trim().split(/\s*,\s*/g).map(function(i2) {
            return selector_1.replace(/&/g, i2);
          }).join(", ") : selector_1.replace(/&/g, parent);
        }
        i.updateMeta({type: layer, group, order});
        _this._addCache(i);
      });
    } else if (parentType === "atRule") {
      var atrule_1 = parent;
      if (this.processor) {
        var directives = this._handleDirectives(parent);
        if (directives) {
          if ("atrule" in directives) {
            atrule_1 = directives.atrule;
          } else if ("layer" in directives) {
            atrule_1 = void 0;
            layer = directives.layer;
            order = layerOrder[layer];
            group = "layer-block";
          } else if ("variants" in directives) {
            var output = [];
            for (var _i = 0, _a = directives.variants; _i < _a.length; _i++) {
              var variant = _a[_i];
              var wrapper = this.processor.wrapWithVariants(variant, styles);
              if (wrapper)
                output = output.concat(wrapper);
            }
            output.map(function(i) {
              i.updateMeta({type: layer, group, order});
              _this._addCache(i);
            });
            return output;
          }
        }
      }
      styles.filter(function(i) {
        return !(i instanceof Keyframes);
      }).forEach(function(i) {
        i.atRule(atrule_1);
        i.updateMeta({type: layer, group, order});
        _this._addCache(i);
      });
    }
    return styles;
  };
  CSSParser2.prototype.parse = function(css, parent, parentType) {
    var _this = this;
    var _a;
    if (css === void 0) {
      css = this.css;
    }
    var styleSheet = new StyleSheet();
    css = this._removeComment(css);
    if (!css || isSpace(css))
      return styleSheet;
    var index = 0;
    var firstLetter = searchFrom(css, /\S/, index);
    var _loop_1 = function() {
      var propEnd = searchPropEnd(css, index);
      var nestStart = searchFrom(css, "{", firstLetter);
      if (propEnd === -1 || nestStart !== -1 && propEnd > nestStart) {
        var selector = css.substring(firstLetter, nestStart).trim();
        index = nestStart + 1;
        var nestEnd = this_1._searchGroup(css, index);
        if (nestEnd === -1)
          return "break";
        var rule = css.slice(index, nestEnd);
        if (!/[};]\s*$/.test(rule))
          rule = rule + ";";
        var content = this_1.parse(rule, selector);
        index = nestEnd + 1;
        styleSheet.add(this_1._generateNestStyle(content.children, selector, css.charAt(firstLetter) === "@" ? "atRule" : "selector"));
      } else if (css.charAt(firstLetter) === "@") {
        var data = css.slice(firstLetter, propEnd);
        if (this_1.processor) {
          var directives_1 = this_1._handleDirectives(data.trim());
          if (directives_1) {
            if ("atrule" in directives_1) {
              var atRule = InlineAtRule.parse(directives_1.atrule);
              if (atRule)
                styleSheet.add(this_1._generateNestProperty(atRule, parent, parentType));
            } else if ("apply" in directives_1 && directives_1.apply) {
              var result = this_1.processor.compile(directives_1.apply, void 0, false, false, function(ignored) {
                if ("." + ignored in _this._cache)
                  return _this._cache["." + ignored];
              });
              styleSheet.add(result.styleSheet.clone().children.map(function(i) {
                var _a2;
                if (!(i instanceof Keyframes)) {
                  i.selector = void 0;
                  i.important = (_a2 = directives_1.important) !== null && _a2 !== void 0 ? _a2 : false;
                }
                return i;
              }));
            }
          }
        } else {
          var atRule = InlineAtRule.parse(data);
          if (atRule)
            styleSheet.add(this_1._generateNestProperty(atRule, parent, parentType));
        }
        index = propEnd + 1;
      } else {
        var prop = Property.parse(css.slice(firstLetter, propEnd));
        index = propEnd + 1;
        if (prop) {
          if (Array.isArray(prop)) {
            prop.filter(function(p) {
              var _a2;
              return (_a2 = p.value) === null || _a2 === void 0 ? void 0 : _a2.match(/theme\([^)]*\)/);
            }).forEach(function(p) {
              return p.value = _this._loadTheme(p.value);
            });
          } else if ((_a = prop.value) === null || _a === void 0 ? void 0 : _a.match(/theme\([^)]*\)/)) {
            prop.value = this_1._loadTheme(prop.value);
          }
          styleSheet.add(this_1._generateNestProperty(prop, parent, parentType));
        }
      }
      firstLetter = searchFrom(css, /\S/, index);
    };
    var this_1 = this;
    while (firstLetter !== -1) {
      var state_1 = _loop_1();
      if (state_1 === "break")
        break;
    }
    if (!parent)
      this._cache = {};
    return styleSheet.combine();
  };
  return CSSParser2;
}();
var ClassParser = function() {
  function ClassParser2(classNames, separator) {
    if (separator === void 0) {
      separator = ":";
    }
    this.classNames = classNames;
    this.separator = separator;
    this.index = 0;
  }
  ClassParser2.prototype._handle_group = function(removeDuplicated) {
    if (removeDuplicated === void 0) {
      removeDuplicated = true;
    }
    if (!this.classNames)
      return [];
    var char;
    var group;
    var func;
    var variant;
    var variants = [];
    var variantStart = this.index + 1;
    var classStart = this.index + 1;
    var groupStart = this.index + 1;
    var important = false;
    var ignoreSpace = false;
    var ignoreBracket = false;
    var insideSquareBracket = false;
    var parts = [];
    var length = this.classNames.length;
    while (this.index < length) {
      this.index++;
      char = this.classNames.charAt(this.index);
      if (insideSquareBracket) {
        if (" \n	\r".includes(char)) {
          insideSquareBracket = false;
        } else {
          if (char === "]")
            insideSquareBracket = false;
          continue;
        }
      }
      switch (char) {
        case "!":
          important = true;
          break;
        case this.separator:
          variant = this.classNames.slice(variantStart, this.index);
          variants.push(variant.charAt(0) === "!" ? variant.slice(1) : variant);
          variantStart = this.index + 1;
          ignoreSpace = true;
          break;
        case "[":
          insideSquareBracket = true;
          break;
        case "(":
          if (this.classNames.charAt(this.index - 1) === "-") {
            ignoreBracket = true;
          } else if (ignoreSpace) {
            group = this._handle_group();
          } else {
            func = this.classNames.slice(groupStart, this.index);
            group = this._handle_function();
          }
          ignoreSpace = false;
          break;
        case ")":
        case " ":
        case "\n":
        case "	":
        case "\r":
          if (!ignoreSpace) {
            if (groupStart !== this.index) {
              var raw = this.classNames.slice(classStart, this.index);
              var start = classStart - 1;
              var end = this.index - 1;
              if (Array.isArray(group)) {
                parts.push({raw, start, end, variants, content: group, type: "group", important});
                group = void 0;
              } else if (func) {
                parts.push({raw, start, end, variants, func, content: group, type: "func", important});
                func = void 0;
              } else if (ignoreBracket) {
                var utility = this.classNames.slice(variantStart, this.index + 1);
                parts.push({raw: raw + ")", start, end: this.index, variants, content: utility.charAt(0) === "!" ? utility.slice(1) : utility, type: "utility", important});
              } else {
                var utility = this.classNames.slice(variantStart, this.index);
                parts.push({raw, start, end, variants, content: utility.charAt(0) === "!" ? utility.slice(1) : utility, type: "utility", important});
              }
              variants = [];
              important = false;
            }
            groupStart = this.index + 1;
            classStart = this.index + 1;
          }
          variantStart = this.index + 1;
          break;
        default:
          ignoreSpace = false;
      }
      if (char === ")") {
        if (!ignoreBracket)
          break;
        ignoreBracket = false;
      }
    }
    if (removeDuplicated) {
      var newParts_1 = [];
      var cache_1 = [];
      parts.forEach(function(item) {
        if (!cache_1.includes(item.raw)) {
          cache_1.push(item.raw);
          newParts_1.push(item);
        }
      });
      return newParts_1;
    }
    return parts;
  };
  ClassParser2.prototype._handle_function = function() {
    if (!this.classNames)
      return;
    var groupStart = this.index + 1;
    while (this.classNames.charAt(this.index) !== ")") {
      this.index++;
    }
    return this.classNames.slice(groupStart, this.index);
  };
  ClassParser2.prototype.parse = function(removeDuplicated) {
    if (removeDuplicated === void 0) {
      removeDuplicated = true;
    }
    if (!this.classNames)
      return [];
    this.classNames = "(" + this.classNames + ")";
    var elements = this._handle_group(removeDuplicated);
    this.index = 0;
    this.classNames = this.classNames.slice(1, -1);
    return elements;
  };
  return ClassParser2;
}();

// src/utils/parser.ts
var Parser = class {
  constructor(classNames) {
    this.classNames = classNames;
  }
  parse(removeDuplicates = true) {
    const windiElements = new ClassParser(this.classNames).parse(removeDuplicates);
    const ast = windiElements.map((el) => this._parse(el));
    return ast;
  }
  _parse({
    content,
    variants,
    important
  }) {
    if (Array.isArray(content)) {
      return {
        content: content.map((el) => this._parse(el)),
        variants,
        important
      };
    }
    return {content: content || "", variants, important};
  }
};
var parser_default = Parser;

// src/utils/index.ts
function isSameArray(arr1, arr2) {
  if (arr1 === arr2)
    return true;
  if (arr1.length != arr2.length)
    return false;
  const a = arr1.slice().sort();
  const b = arr2.slice().sort();
  for (let i = 0; i < a.length; i++) {
    if (a[i] !== b[i]) {
      return false;
    }
  }
  return true;
}

// src/utils/combiner.ts
var Combiner = class {
  constructor(parsedElements) {
    this.parsedElements = parsedElements;
    this.combinedElements = [];
  }
  combine() {
    this.combinedElements = [];
    this.parsedElements.forEach((el) => {
      this._combine(el);
    });
    return this.combinedElements;
  }
  _combine({content, variants, important}, vars = [], imp = false) {
    const combineVariants = vars.concat(variants);
    const importance = important || imp;
    if (Array.isArray(content)) {
      content.forEach((element) => {
        this._combine(element, combineVariants, importance);
      });
    } else {
      const innerEl = {
        content,
        important: importance
      };
      const groupEl = this.combinedElements.find((targetEl) => isSameArray(targetEl.variants, combineVariants));
      if (groupEl) {
        groupEl.content.push(innerEl);
      } else {
        this.combinedElements.push({
          content: [innerEl],
          variants: combineVariants
        });
      }
    }
  }
};
var combiner_default = Combiner;

// src/utils/separator.ts
var Separator = class {
  constructor(sorterElements, unknownClassList) {
    this.sorterElements = sorterElements;
    this.unknownClassList = unknownClassList;
  }
  separate() {
    const windiElements = [];
    const unknownElements = [];
    this.sorterElements.forEach((sorterEl) => {
      sorterEl.content.forEach((innerEl) => {
        const target = this.isWindiUtility(innerEl.content, sorterEl.variants) ? windiElements : unknownElements;
        const groupEl = target.find((targetEl) => isSameArray(targetEl.variants, sorterEl.variants));
        if (groupEl) {
          groupEl.content.push(innerEl);
        } else {
          target.push({
            content: [innerEl],
            variants: sorterEl.variants
          });
        }
      });
    });
    return {
      windiElements,
      unknownElements
    };
  }
  isWindiUtility(className, variants) {
    const isUnknown = this.unknownClassList.find((cls) => {
      const clsHeads = cls.split(":");
      const clsName = clsHeads.pop();
      return className === clsName && isSameArray(clsHeads, variants);
    });
    return !isUnknown;
  }
};
var separator_default = Separator;

// src/utils/weighter.ts
var Weighter = class {
  constructor(priorityOrderList, windiVariants) {
    this.priorityOrderList = priorityOrderList;
    this.windiVariants = windiVariants;
  }
  weighting(elements) {
    const weightElements = elements.map((sorterEl) => {
      const weighterContent = Array.isArray(sorterEl.content) ? sorterEl.content.map((innerEl) => {
        return {
          ...innerEl,
          contentWeight: this.computeContentWeight(innerEl.content)
        };
      }) : sorterEl.content;
      return {
        content: weighterContent,
        variants: sorterEl.variants,
        variantsWeight: this.computeVariantsWeight(sorterEl.variants)
      };
    });
    return weightElements;
  }
  computeContentWeight(content) {
    const utility = this.pickUtility(content);
    const prioritizedWeight = this.priorityOrderList.indexOf(utility) + 1;
    const unprioritizedWeight = this.computeUnprioritizedWeight();
    const contentWeight = prioritizedWeight ? prioritizedWeight : unprioritizedWeight;
    return contentWeight;
  }
  computeVariantsWeight(variants) {
    const variantsWeight = this.windiVariants.slice().reverse().reduce((acc, value, index) => {
      if (variants.includes(value)) {
        return acc + BigInt(1);
      }
      if (acc > 0) {
        return acc + BigInt("0b1" + "0".repeat(index));
      }
      return acc;
    }, BigInt(0));
    const unknownVariants = variants.filter((variant) => !this.windiVariants.includes(variant));
    const unknownWeight = unknownVariants.length ? BigInt("0b1" + "0".repeat(this.windiVariants.length)) : BigInt("0");
    return variantsWeight + unknownWeight;
  }
  pickUtility(content) {
    const utility = content.match(/\w+/);
    if (Array.isArray(utility)) {
      return utility[0] || "";
    }
    return "";
  }
  computeUnprioritizedWeight() {
    const prioritizedCount = this.priorityOrderList.length;
    const len = String(prioritizedCount).length;
    return 10 ** (len + 1);
  }
};
var weighter_default = Weighter;

// src/utils/sorter.ts
var Sorter = class {
  constructor(sortOrder, windiVariants) {
    this.sortOrder = sortOrder;
    this.windiVariants = windiVariants;
  }
  sort(el) {
    const res = el.map((sorterEl) => {
      sorterEl.content.sort((a, b) => {
        return this.compareInnerElement(a, b);
      });
      this.sortVariants(sorterEl);
      return sorterEl;
    });
    res.sort((a, b) => {
      return this.compareSorterElement(a, b);
    });
    return res;
  }
  sortVariants(el) {
    el.variants.sort((a, b) => this.windiVariants.indexOf(a) - this.windiVariants.indexOf(b));
    return el;
  }
  compareSorterElement(a, b) {
    if (a.variantsWeight < b.variantsWeight)
      return -1;
    if (a.variantsWeight > b.variantsWeight)
      return 1;
    return 0;
  }
  compareInnerElement(a, b) {
    if (!a.important && b.important)
      return -1;
    if (a.important && !b.important)
      return 1;
    if (a.contentWeight < b.contentWeight)
      return -1;
    if (a.contentWeight > b.contentWeight)
      return 1;
    if (typeof a.content === "string" && typeof b.content === "string") {
      if (a.content < b.content) {
        return this.sortOrder === "asc" ? -1 : 1;
      }
      if (a.content > b.content) {
        return this.sortOrder === "asc" ? 1 : -1;
      }
    }
    return 0;
  }
};
var sorter_default = Sorter;

// src/utils/outputter.ts
var Outputter = class {
  constructor(sorterElements) {
    this.sorterElements = sorterElements;
  }
  output(useVariantGroup) {
    const classNames = this.sorterElements.map((sorterEl) => {
      const head = sorterEl.variants.length ? `${sorterEl.variants.join(":")}:` : "";
      const innerCls = sorterEl.content.map((innerEl) => {
        return useVariantGroup ? `${innerEl.important ? "!" : ""}${innerEl.content}` : `${head}${innerEl.important ? "!" : ""}${innerEl.content}`;
      }).join(" ");
      return useVariantGroup && head ? `${head}(${innerCls})` : `${innerCls}`;
    });
    return classNames.join(" ");
  }
};
var outputter_default = Outputter;

// src/index.ts
var NAME = "windicss-sorter";
var WindiSorter = class {
  constructor(opts = {}, utils) {
    this.priorityOrderList = opts.priorityOrderList || [];
    this.sortOrder = opts.sortOrder || "asc";
    this.sortUnknowns = typeof opts.sortUnknowns === "boolean" ? opts.sortUnknowns : true;
    this.unknownClassNamesPosition = opts.unknownClassNamesPosition || "end";
    this.removeDuplicateClassNames = typeof opts.removeDuplicateClassNames === "boolean" ? opts.removeDuplicateClassNames : true;
    this.useVariantGroup = typeof opts.useVariantGroup === "boolean" ? opts.useVariantGroup : true;
    this.utils = utils;
  }
  static async init(opts = {}, userOptions = {}) {
    const utils = _pluginutils.createUtils.call(void 0, userOptions, {name: NAME});
    const sorter = new WindiSorter(opts, utils);
    await sorter.utils.init();
    return sorter;
  }
  getWindiVariants() {
    const variants = Object.keys(_nullishCoalesce(this.utils.processor.resolveVariants(), () => ( {})));
    const windiVariants = [...variants.map((value) => value)];
    return windiVariants;
  }
  sortClassNames(classNames) {
    const unknownClasses = this.utils.processor.interpret(classNames).ignored;
    const windiVariants = this.getWindiVariants();
    const parsedElements = new parser_default(classNames).parse(this.removeDuplicateClassNames);
    const combinedElements = new combiner_default(parsedElements).combine();
    const separatedElements = new separator_default(combinedElements, unknownClasses).separate();
    const weighter = new weighter_default(this.priorityOrderList, windiVariants);
    const windiElementsWithWeight = weighter.weighting(separatedElements.windiElements);
    const unknownElementsWithWeight = weighter.weighting(separatedElements.unknownElements);
    const sorter = new sorter_default(this.sortOrder, windiVariants);
    const windiElements = sorter.sort(windiElementsWithWeight);
    const unknownElements = this.sortUnknowns ? sorter.sort(unknownElementsWithWeight) : separatedElements.unknownElements;
    const concatenatedElements = this.unknownClassNamesPosition === "start" ? unknownElements.concat(windiElements) : windiElements.concat(unknownElements);
    const output = new outputter_default(concatenatedElements).output(this.useVariantGroup);
    return output;
  }
};
var src_default = WindiSorter;


exports.default = src_default;
